
/*
 * Demo program for libgnet
 * Copyright (C) 1997 Indrek Mandre (indrek@warp.edu.ee)
 * This programme is free software which belongs under the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>

#include "gnet.h"

int main ()
{
 struct timeval tv;
 GN_conn *serv;
 char name[256];
 char host[256];
 char port[256];
 fd_set fd;

 printf ("Please enter host to contact: ");	/* Ask ports and hosts stuff */
   gets ( host );
 printf ("Please enter port number: ");
   gets ( port );

 if ( ( serv = GN_connect ( NET_INTERNET, host, atoi ( port ), CON_SEQPACKET ) ) == NULL ) {
 	fprintf ( stderr, GN_error );
 	exit (0);			/* Connecting to server */
 }

 printf ("Connected... please enter your name: ");  /* At first send out name */
 gets ( name );
 name[255] = 0;

 GN_send_data ( serv, name, strlen ( name ) + 1 );

 for (;;) {				/* Infinite loop */

    FD_ZERO ( &fd );			/* Check if user has written something */
    FD_SET ( STDIN_FILENO, &fd );	/* to stdin */

    tv.tv_usec = 0;
    tv.tv_sec = 0;

    select ( 32, &fd, NULL, NULL, &tv );

    if ( FD_ISSET ( STDIN_FILENO, &fd ) ) {	/* If has, send it to server */
    	char data[16384];

    	gets ( data );
    	if ( GN_send_udp_data ( serv, data, strlen ( data ) + 1 ) <= 0 ) {
    		printf ("Connection to server closed, exiting...\n");
    		exit (0);
    	}
    }

    GN_check_conn ( serv );		/* Check if something has come from server */

    if ( GN_is_udp_data ( serv ) ) {
    	char	data[16384];
					/* If has then get it */
    	if ( GN_recv_udp_data ( serv, data, 16384 ) <= 0 ) {
    		printf ("Connection to server closed, exiting...\n");
    		exit (0);
    	}

    	printf ("%s\n", data );		/* And print it out */

    }

    usleep (10000);			/* Let's not waste too much time */

 }

 return 0;
}

